<?php
/* ===========================================================================================
	GALLERYX V1.2    defination file
	GALLERYX V1.2    27.11.08 - 11.12.08
	GALLERYX V1.2.1  11.01.09 update for better caption text in lightbox
	GALLERYX V1.2.2  04.02.09 update for special image in sub gallery, new sort by number implemented
	                 21.02.09 optional faster thumbs/images output (processing during first call in fe)
	The original script gallery.php programmed by (c) Oliver Georgi 
	06.10.08 {GALLERYX} patched by K.Heermann (flip-flop) http://planmatrix.de
	                    and  RCS / robin c. sherwood
	More information: Have a look into  galeryx_readme.txt
	
	forum v1.0/1: http://forum.phpwcms.org/viewtopic.php?p=110248#p110248
	forum:v1.2.x  http://forum.phpwcms.org/viewtopic.php?p=112442#p112442
 ============================================================================================= */
// ------------------------------------------------------------------
// obligate check for phpwcms constants
if (!defined('PHPWCMS_ROOT')) {
   die("You Cannot Access This Script Directly, Have a Nice Day."); }
// ------------------------------------------------------------------


// ===============================================================
// SHORT DEFINATION ==============================================
// ===============================================================

// =====================================================
// list sub gallery defination 
// =====================================================
// string defines the sorting mode of the Gallery and list Sub Galleries:
	// RAND 
	// SORT-ASC, SORT-DESC, SORT-NAME-ASC, SORT-NAME-DESC, SORT-CREATE-ASC, SORT-CREATE-DESC  (since r304)
	// NAME-ASC, NAME-DESC, CREATE-ASC, CREATE-DESC
$my_gallery_sort									= 'SORT-NAME-ASC'; 

$my_date_format										= '{DATE:d.m.y lang=DE}';

// [0|1|2|3] [off | title=on | date=on | title and date = on]   in sub gallery (list)
$my_list_title_date								= 3; 

$my_list_title_prefix							= '<h3>[LINK]'; // list_title_date [1|2|3]
$my_list_title_suffix							= '[/LINK]</h3>';
$my_list_title_date_prefix				= '<strong>';  	// list_title_date [2|3]
$my_list_title_date_suffix				= '</strong> ';


// LIST DESCRIPTION (general) --------------------------
// [0|1|2|3] [0=off | 1=info |2=off | 3=info and date ]   in sub gallery
$my_list_descr_info_date_on				= 3; 	// [0|1|2|3] Show description in list -> no separate date available

$my_list_descr_prefix							= '<div class="list-descr">';  // '<div style="font-size: 11px">';
$my_list_descr_suffix							= '</div>';
$my_list_descr_date_prefix 				= '<strong>';
$my_list_descr_date_suffix 				= '</strong> &#8211; ';


// LIST THUMB ------------------------------------------

// string defines the sorting mode of the list Sub Gallery thumbs:
	// RAND = get images by random)
	// SORT-ASC, SORT-DESC, SORT-NAME-ASC, SORT-NAME-DESC, SORT-CREATE-ASC, SORT-CREATE-DESC  (since r304)
	// NAME-ASC, NAME-DESC, CREATE-ASC, CREATE-DESC, 
	// LIST-SPECIAL-IMG -> A special thumb for gallery listing with sort number = -1, -2, -3, ....
$my_list_thumbnail_sort						= 'LIST-SPECIAL-IMG';
// $my_list_thumbnail_sort						= '';

// define if an list sub gallery thumbnail should be shown
// 0 = show none, 1 show first, 2 show first and second ...
$my_list_thumbnail 								= 1; 		// [0, 1, 2, 3 ....] output 
$my_list_thumbnail_caption 				= 1; 		// [0|1] caption off/on (precondition: $my_list_descr_info_date_on = on )
$my_list_thumbnail_crop						= 1; 		// [0|1] cropping with $my_list_thumbnail_width_height
$my_list_thumbnail_width_height 	= '50x50';	// width x height
$my_list_thumbnail_prefix					= '<div class="thumbnail">[LINK]';
$my_list_thumbnail_suffix					= '[/LINK]</div>';

// OTHER -----------------------------------------------
// define what kind of file storage folders should be taken
// true = only folders marked as gallery root or sub directory
$gallery->gallery_only = true; 

// gallery name can be prefixed by date YYYY-MM-DD, use sort by NAME-ASC or NAME-DESC,
// this date will be used as gallery date and is stripped from name if $use_name_date = true
$gallery->use_name_date	= true;


// =====================================================
// sub sub gallery definition 
// =====================================================
// string defines the sorting mode
// ASC / DESC = get images sorted by date 
// NAME-ASC / NAME_DESC = get images sorted by name  (+kh) 
// RAND = get images by random)
// SORT-ASC, SORT-DESC, SORT-NAME-ASC, SORT-NAME-DESC, SORT-CREATE-ASC, SORT-CREATE-DESC  (since r304)
// NAME-ASC, NAME-DESC, CREATE-ASC, CREATE-DESC

$my_gallery_image_sort			= 'SORT-NAME-ASC'; 	// sorting gallery images
$my_gallery_image_limit			= 50; 							// integer the limit of how many images should be retrieved

// [0|1|2|3] [0=off | 1=title |2=date | 3=title and date ]   in sub sub gallery
$my_detail_title_date_on			= 3; 

// caption set in sub sub gallery -> caption and/or lightbox
// [0|1|2|3] [0=off | 1=capt |2=light | 3=capt&light ]   in sub sub gallery
$my_detail_caption_on 				= 2; // default [3]

// special linebreak in caption/copyright for lightbox solves the \n\t problem
$my_detail_cc_light_linebreak 	= 1; // [0|1] [0=off (old behavior) | 1=on (no [BR] needed for linebreak)]

$my_detail_capt_thumb_title_on 	= 0; // Caption text not formatted in title (hover) very basic

// caption fallback text if there is no one in db 
$my_detail_caption_text			= ''; // the caption text for sub sub and lightbox

// thumb text: title for hover and alt for thumb image
// only for lightbox: important for a right caption carry to lightbox
// blank: filename.ext is generated for title text
// At filecenter info field you can use the tag[TT]......[/TT] for setting up too
$my_detail_caption_title		= ''; // the thumb title text

// blank: filename.ext is generated for alt text
// At filecenter info field you can use the tag[AT]......[/AT] for setting up too
$my_detail_caption_alt			= ''; // the thumb alt text

$my_detail_descr_info 				= 0; 					// [0|1] Show description from list in detail off/on

$my_detail_descr_prefix				=  '<div class="detail-descr">'; // '<div style="font-size: 11px">';
$my_detail_descr_suffix				= '</div>';

// COPYRIGHT -------------------------------------------
// ------ copyright set in:
// [0=off|1=cap|2=light|3=capt&light|4=down|5=down&capt|6=down&light|7=down&light&capt]
// More informations see galleryx_main_vxx_doc.txt
// -------- 
$my_detail_copyr_on						= 2;  									// download & lightbox & caption = on

$my_detail_copyr_text					= '[&copy; 20xx name]';	// your fallback text if there is no in db or parameter

$my_detail_copyr_text_prefix	= '&copy; '; 
$my_detail_copyr_prefix				=  '<div class="detail-copyr">';  // '<div style="font-size: 10px">';
$my_detail_copyr_suffix				= '</div>';

// GALLERY THUMBS ======================================
// sub sub gallery thumbs

$my_detail_thumb_fast_output	= 1;					// processing of all thumbs/images during first call of the galleryx [0|1]

$my_detail_thumb_crop					= 0;					// cropping the image [0|1]
$my_detail_thumb_width_height	= '120x100';	// thumb width x height

// If more then "thumb_count_to_min" images in selected sub sub gallery placed, 
// they will be reduced to "thumb_width_height_min" 
$my_detail_thumb_count_to_min 			= 30; 		// [integer]
$my_detail_thumb_width_height_min 	= '100x100';// minimal thumb width x height


// ------ zoom detail
// [0|1|3|5|7] (int) in sub sub gallery
// [0=off|1=zoom|3=light&zoom|5=crop&zoom|7=crop&light&zoom]
// -------- 
$my_detail_crop_light_zoom_on	=	3; // default [3] no cropping

$my_detail_zoom_width_height	= '800x600';	// width x height of the zoomed image


// DOWNLOAD --------------------------------------------
// ------ download
// combination of download = 1, download_direct = 0 and $phpwcms['inline_download'] = 0; (conf.inc.php) 
// would open a new dialog window with listed real filename
//
// [0|1|3] (int) in sub gallery (list)
// [0=off|1=download|3=download & direct]
// ------- 
$my_download_on						= 0; 

// download template in /template/inc_cntpart/filelist/*.html
$my_item_download_template		= 'galleryx';  // only the name of the html file without the extend!!!

// OTHER -----------------------------------------------
$my_go_back_text					= 'Go Back';	// go back link text
// $my_go_back_text				= '[en]Go Back[/en][de]zur&uuml;ck[/de]';	// e.g. for active lang. switch

// css file in /template/inc_css/specific/*.css
$my_gallery_css								= 'galleryx';  // only the name of the css file without the extend!!!

// ===============================================================
// END SHORT DEFINITION ==========================================
// ===============================================================



// Basic tag: {GALLERYX: galleryRoot_ID[int],  subgallery_ID[int], subsubgallery_ID[int]}
// ===========================================================================================
//	Input parameter (handing over)
// ===========================================================================================
	$parameter              = explode(',', trimhtml($parameter));
	$my_gallery_rootid      = empty($parameter[0]) ? 0  : intval($parameter[0]);
	$my_gallery_subid       = empty($parameter[1]) ? 0  : intval($parameter[1]);
	$my_gallery_sub_subid   = empty($parameter[2]) ? 0  : intval($parameter[2]);

//	Some examples how a new parameter in your tag could be look like.	

//	$my_list_descr_info_date_on     = empty($parameter[3]) ? 1   : intval($parameter[3]);
//	$my_detail_title_date_on        = empty($parameter[4]) ? 3   : intval($parameter[4]);
//	$my_detail_crop_light_zoom_on   = empty($parameter[5]) ? 3   : intval($parameter[5]);
//	$my_detail_thumb_count_to_min   = empty($parameter[6]) ? 20  : intval($parameter[6]);
//	$my_detail_thumb_width_height   = empty($parameter[7]) ? '60x60'    :  trim($parameter[7]);
//	$my_gallery_css                 = empty($parameter[8]) ? 'galleryx' : trim($parameter[8]);
//	$my_detail_copyr_on             = empty($parameter[9]) ? 3          : trim($parameter[9]);
//	$my_detail_copyr_text           = empty($parameter[10]) ? '(c) Max Muster'  : trim($parameter[9]);
// ===========================================================================================

?>