<?php
/* ===========================================================================================
	GALLERYX V1.2    27.11.08 - 11.12.08
	GALLERYX V1.2.1  11.01.09 update for better caption text in lightbox
	GALLERYX V1.2.2  04.02.09 update for special image in sub gallery, new sort by number implemented
	                 21.02.09 optional faster thumbs/images output (processing during first call in fe)
	The original script gallery.php programmed by (c) Oliver Georgi 
	06.10.08 {GALLERYX} patched by K.Heermann (flip-flop) http://planmatrix.de
	                    and  RCS / robin c. sherwood
	06.10.08 {GALLERYX: galleryRoot_ID[int],  subgallery_ID[int], subsubgallery_ID[int]}
	More information: Have a look into  galeryx_readme.txt
	
	forum v1.0/1: http://forum.phpwcms.org/viewtopic.php?p=110248#p110248
	forum:v1.2.x  http://forum.phpwcms.org/viewtopic.php?p=112442#p112442
 ============================================================================================= */
 
// ------------------------------------------------------------------
// obligate check for phpwcms constants
if (!defined('PHPWCMS_ROOT')) {
   die("You Cannot Access This Script Directly, Have a Nice Day."); }
// ------------------------------------------------------------------

// load phpwcmsImageGallery class
include_once(PHPWCMS_ROOT.'/include/inc_lib/imagegalleryx122.inc.php');

function my_parameter($parameter='') {

$gallery = & new phpwcmsImageGalleryX (); // kh: binding the php class
//$gallery->setQuerySeparator('?');


// ===================================================================
// load phpwcmsImageGallery parameter set
	include_once(PHPWCMS_ROOT.'/template/inc_script/galleryx/galleryx_main_v122.inc.php');
// ===================================================================


// Assign to variables ===========================================

// strip WIDTHxHEIGHT into an array -------------
// list sub gallery thumbs
$my_list_thumbnail_width_height_array 		= explode('x', str_replace(' ','',$my_list_thumbnail_width_height));
// sub sub gallery thumbs
$my_detail_thumb_width_height_array 		= explode('x', str_replace(' ','',$my_detail_thumb_width_height));
// sub sub gallery thumbs if image count in folder > thumb_count_min 
$my_detail_thumb_width_height_min_array 	= explode('x', str_replace(' ','',$my_detail_thumb_width_height_min));
// sub sub gallery width x height of the zoomed image
$my_detail_width_height_array 				= explode('x', str_replace(' ','',$my_detail_zoom_width_height));

// +kh: automatic article id
$my_article_id = 	0; 	// kh alias from the calling article where {GALLERYX:...} is stored
 if(!empty($GLOBALS['row']["article_id"])) { $my_article_id = $GLOBALS['row']["article_id"]; } 


// define the root ID of gallery = where to start recursive search
// by default root ID = 0 which is top level
 $gallery->gallery_rootid	= $my_gallery_rootid; // Gallery folder root (parent)

// define the sub_sub gallery id = default 0
// only this gallery 
 $gallery->gallery_sub_subid = $my_gallery_sub_subid; 


if ($GLOBALS["phpwcms"]["rewrite_url"] == 0) {
 		 $gallery->setAlias( 'aid='.$my_article_id );  // alias from the calling article where {GALLERYX:...} is stored
}

// string defines the sorting mode of the Gallery and Sub Galleries image folder:
// NAME-ASC, NAME-DESC, CREATE-ASC, CREATE-DESC
// get images sorted by name or create date
// $gallery->gallery_sort	= 'NAME-ASC';
$gallery->setGallerySort($my_gallery_sort);

/* not in use
$gallery->list_image_width		= 70;
$gallery->list_image_height		= 70;
$gallery->list_image_crop			= 0;
*/


// bbbbbbbbbbbbbbbbbbbb ======== SUB GALLERY LIST ===========
$gallery->list_template				= '	<div class="gallery">
	{TITLE}
	{THUMBNAIL}
	{DESCRIPTION}
	<div class="clear_both"></div>
</div>';

$gallery->list_title_date					= $my_list_title_date;

			switch ($my_list_title_date) {  // title and date in sub gallery (list)
			//	case 0: 
			// set in imagegalleryx.inc.php (we need a fallback if there is no thumbnail set)
				
				case 1: 
					$gallery->list_title_prefix	= $my_list_title_prefix;  //only title [1]
					break;
				case 2: 
					$gallery->list_title_prefix	= $my_list_title_prefix . $my_list_title_date_prefix . $my_date_format . $my_list_title_date_suffix;
					break;
				default: // [0 and 3]
					$gallery->list_title_prefix	= $my_list_title_prefix . $my_list_title_date_prefix . $my_date_format . $my_list_title_date_suffix.' &#8211; ';
					break;
			}
			$gallery->list_title_suffix	= $my_list_title_suffix;
			
$gallery->list_thumbnail_prefix		= $my_list_thumbnail_prefix;
$gallery->list_thumbnail_suffix		= $my_list_thumbnail_suffix;
// eeeeeeeeeeeeeeeeeeee

// string defines the sorting mode of the list Sub Gallery thumbs:
$gallery->list_thumbnail_sort			= $my_list_thumbnail_sort;

// automatic assign for the list thumbnail (see user assign)
if (isset($my_list_thumbnail_width_height_array[1])) {
	$gallery->list_thumbnail_width		= intval ($my_list_thumbnail_width_height_array[0]);
	$gallery->list_thumbnail_height		= intval ($my_list_thumbnail_width_height_array[1]);
} else { 
// bbbbbbbbbbbbbbbbbbbb
	$gallery->list_thumbnail_width		= 50;  // default fallback
	$gallery->list_thumbnail_width		= 50;  // default fallback
// eeeeeeeeeeeeeeeeeeee
	}

// define if an list sub gallery thumbnail should be shown
// 0 = show none, 1 show first, 2 show first and second ...(see user assign)
$gallery->list_thumbnail				= $my_list_thumbnail;
$gallery->list_thumbnail_crop		= (boolean) $my_list_thumbnail_crop;

$gallery->list_thumbnail_caption	= (boolean) $my_list_thumbnail_caption;  // +kh

// bbbbbbbbbbbbbbbbbbbb

$gallery->list_descr_info_date_on	= $my_list_descr_info_date_on;

$gallery->list_descr_prefix				= $my_list_descr_prefix;

// [0|1|2|3] [0=off | 1=info |2=off | 3=info and date ]   in sub gallery (list)
if ($gallery->has_flag($my_list_descr_info_date_on,3)) {  // date set? -> add date
		$gallery->list_descr_prefix	.= $my_list_descr_date_prefix . $my_date_format . $my_list_descr_date_suffix; 
}
$gallery->list_descr_suffix			= $my_list_descr_suffix;
// eeeeeeeeeeeeeeeeeeee

// zoom and lightbox switch
// [0=off|1=zoom|3=light&zoom|4=crop|5=light&zoom|6=crop&light|6=crop&light&zoom]
$gallery->zoom 								= $gallery->has_flag($my_detail_crop_light_zoom_on, 1) ;
$gallery->lightbox 						= $gallery->has_flag($my_detail_crop_light_zoom_on, 3) ;

// [0|1] [0=off (old behavior) | 1=on (no [BR] needed for linebreak)]
$gallery->lightbox_linebreak	= (boolean) $my_detail_cc_light_linebreak; 

// build download template file name 
$gallery->item_download_template = trimhtml($my_item_download_template) . '.html';

// END of Assign to variables ====================================


// ------------ +kh: including the css file
$GLOBALS['block']['css']['gallery'] = 'specific/'. trim($my_gallery_css) . '.css'; 
// ------------

	$galleries = array();

// ------------ +kh: fetch the sub gallery id, if there is no one given 
 if ($my_gallery_subid > 0) {$GLOBALS['_getVar']['subgallery'] = $my_gallery_subid;} 
// ------------


	// List the galleries in selected sub gallery ===============
	if( isset($GLOBALS['_getVar']['subgallery']) ) {

		$GLOBALS['_getVar']['subgallery'] = intval($GLOBALS['_getVar']['subgallery']);
		
		$sql  = 'SELECT pf.*, pj.f_id AS f_root_id, pj.f_name AS f_root_name ';
		$sql .= 'FROM '.DB_PREPEND.'phpwcms_file pf ';
		$sql .= 'LEFT JOIN '.DB_PREPEND.'phpwcms_file pj ';
		$sql .= 'ON pf.f_pid=pj.f_id ';
		$sql .= 'WHERE pf.f_id='.$GLOBALS['_getVar']['subgallery'];

		$subgallery  = _dbQuery($sql);
		
		$gallery_breadcrumb = array();
		
		if(isset($subgallery[0])) {
		
			$subgallery							= $subgallery[0];
			$subgallery_get					= '';
			$subgallery_class				= 'root';
			$gallery_breadcrumb_url	= 'index.php'.returnGlobalGET_QueryString('htmlentities', array(), array('gallery', 'subgallery'), $gallery->alias);
		
			// check if parent directory exists
			if(!empty($subgallery['f_root_id'])) {
				$gallery_breadcrumb[]	= '<a href="'.$gallery_breadcrumb_url.'" class="root">'.html_specialchars($subgallery['f_root_name']).'</a>';
				$subgallery_get				= '&amp;subgallery='.$GLOBALS['_getVar']['subgallery'];
				$subgallery_class			= 'sub';
			}
			$gallery_breadcrumb[] = '<a href="'.$gallery_breadcrumb_url.$subgallery_get.'" class="'.$subgallery_class.'">'.html_specialchars($subgallery['f_name']).'</a>';	
		
		}
		

		// ========================================================
		// show gallery images 
		// ========================================================
		
		if ($my_gallery_sub_subid > 0) {$GLOBALS['_getVar']['gallery'] = $my_gallery_sub_subid;}
		
		if( isset($GLOBALS['_getVar']['gallery']) ) {

		// Define the images ==========================


//		[0=off|1=download|3=download & direct]
			$gallery->download					= $gallery->has_flag($my_download_on,1);
			$gallery->download_direct		= $gallery->has_flag($my_download_on,3);

		// string defines the sorting mode
		// ASC/DESC = get images sorted by date 
		// NAME-ASC/DESC = get images sorted by name  (+kh) 
		// RAND = get images by random)
			$gallery->image_sort			= trim($my_gallery_image_sort); 	// sorting gallery images
			$gallery->image_limit			= trim($my_gallery_image_limit); 	// integer the limit of how many images should be retrieved

			if (isset($my_detail_thumb_width_height_array[1])) {
				$gallery->thumb_width		= intval(trim($my_detail_thumb_width_height_array[0]));
				$gallery->thumb_height	= intval(trim($my_detail_thumb_width_height_array[1]));
			} else { 
				// bbbbbbbbbbbbbbbbbbbb
				$gallery->thumb_width		= 160;  // default
				$gallery->thumb_height	= 160;  // default
				}
				// eeeeeeeeeeeeeeeeeeee
			
			// -------- +kh
			// If more then "thumb_count_to_min" images in selected sub gallery placed, 
			// they will be reduced to "thumb_width_min" and "thumb_height_min"
			$gallery->thumb_count_to_min	= intval($my_detail_thumb_count_to_min);
			
			if (isset($my_thumb_width_height_min_array[1])) {
				$gallery->thumb_width_min		= intval(trim($my_detail_thumb_width_height_min_array[0]));
				$gallery->thumb_height_min	= intval(trim($my_detail_thumb_width_height_min_array[1]));
			} else { 
				// bbbbbbbbbbbbbbbbbbbb
				$gallery->thumb_width_min		= 100;  // default fallback
				$gallery->thumb_height_min	= 100;  // default fallback
				}
				// eeeeeeeeeeeeeeeeeeee
			// --------
			
			if (isset($my_detail_width_height_array[1])) { 
				$gallery->width				= intval(trim($my_detail_width_height_array[0]));
				$gallery->height			= intval(trim($my_detail_width_height_array[1]));
			} else { 
				$gallery->width				= 600;  // default fallback
				$gallery->height			= 480;  // default fallback
				}
				

			$gallery->detail_descr_info		= (boolean) $my_detail_descr_info; // +kh: // +kh: Description from list in detail off/on
			
			// bbbbbbbbbbbbbbbbbbbb
			$gallery->detail_title_date_on		= $my_detail_title_date_on;
//			if ($my_detail_title_date == 1) { $gallery->detail_title_prefix		= '<h2>'; } //only title [1]
//			else { $gallery->detail_title_prefix		= '<h2><strong>'.$my_date_format.'</strong> &#8211; '; }

			$gallery->detail_title_suffix		= '</h2>';
			
			switch ($my_detail_title_date_on) {
				case 0: 
					$gallery->detail_title_prefix		= '';
					$gallery->detail_title_suffix		= '';
					break;
				case 1: 
					$gallery->detail_title_prefix		= '<h2>';
					break;
				case 2: 
					$gallery->detail_title_prefix		= '<h2><strong>'.$my_date_format.'</strong> ';
					break;
				default:
					$gallery->detail_title_prefix		= '<h2><strong>'.$my_date_format.'</strong> &#8211; ';
					break;
			}
			
			$gallery->detail_descr_prefix	= $my_detail_descr_prefix;
			$gallery->detail_descr_suffix	= $my_detail_descr_suffix;
			
			$gallery->detail_gallery_back	= '<div class="backlink">[LINK]'.trimhtml($my_go_back_text).'[/LINK]</div>';
			// eeeeeeeeeeeeeeeeeeee
			
			$gallery->detail_thumbnail_crop			= (boolean) $my_detail_thumb_crop;

			// [0|1|2|3] [0=off | 1=capt |2=light | 3=capt&light ]   in sub sub gallery
			$gallery->detail_caption_on		 				= $my_detail_caption_on;
			
			$gallery->detail_zoom_crop					= (boolean) $my_detail_zoom_crop;
			// bbbbbbbbbbbbbbbbbbbb
			$gallery->detail_thumbnail_prefix		= '<div class="thumbnail"><div class="part_opac">';
			$gallery->detail_thumbnail_suffix		= '<hr />{DOWNLOAD}</div></div>';
			$gallery->detail_caption_prefix			= '<div class="caption">';
			$gallery->detail_caption_suffix			= '</div>';
			$gallery->detail_caption_text			= $my_detail_caption_text;
			$gallery->detail_caption_title		= $my_detail_caption_title;
			$gallery->detail_caption_alt			= $my_detail_caption_alt;
			
			// ----------- +kh: copyright add
			$gallery->detail_copyr_on						= $my_detail_copyr_on;
			
			if ($my_detail_copyr_on) {
				$gallery->detail_copyr_prefix		= $my_detail_copyr_prefix;
				$gallery->detail_copyr_suffix		= $my_detail_copyr_suffix;
//				$gallery->detail_copyr_text			= plaintext_htmlencode(trim($my_detail_copyr_text));  // set general copyright text over all
				$gallery->detail_copyr_text			= trim($my_detail_copyr_text);  // set copyright text if DB is blank
				$gallery->detail_copyr_text_prefix		= $my_detail_copyr_text_prefix; 
			}
			// eeeeeeeeeeeeeeeeeeee
			// -----------
			
			// End of define the images ========================


			// sub sub gallery output
			$galleries[] = $gallery->showGallery( $GLOBALS['_getVar']['gallery'] );
			

		/* ***************************************
		 - direct processing of all images (no more cmsimage.php call). This fasted up the thumb output to 200%
		 - Ersetzt z.B. cmsimage.php/800x600/efcb75f.png 
		 - mit der direkten Bildadresse /content/images/xyz.png
		 */
			if ($my_detail_thumb_fast_output) 
			{
				foreach ( $galleries as $key => $content)
				{ 
//				$galleries[$key] = preg_replace("/cmsimage\.php\/800x600\/(.*?)\" target/ie", "inner_cmsimage ('/800x600/$1').'\" target'",$galleries[$key] );

				$my_gallery_cond = $my_detail_crop_light_zoom_on	==	7 ? $my_detail_zoom_width_height.'x1' : $my_detail_zoom_width_height;
				$galleries[$key] = preg_replace("/cmsimage\.php\/$my_gallery_cond\/(.*?)\" target/ie", "inner_cmsimage ('/$my_gallery_cond/$1').'\" target'",$galleries[$key] );

				$my_gallery_cond = $my_detail_thumb_crop ? $my_detail_thumb_width_height.'x1' : $my_detail_thumb_width_height;
				$galleries[$key] = preg_replace("/cmsimage\.php\/$my_gallery_cond\/(.*?)\" alt/ie", "inner_cmsimage ('/$my_gallery_cond/$1').'\" alt'",$galleries[$key] );

				$galleries[$key] = str_replace($phpwcms['root'].'/img/',$phpwcms['root'].'/content/images/',$galleries[$key] );
				}
			}
		// ***************************************
			
			
			
			
			// show title of selected gallery
			if(isset($gallery->gallery['f_name'])) { 
				$gallery_breadcrumb[] = '<span class="active">'.html_specialchars($gallery->gallery['f_name']).'</span>';	
			}

		} else {  // list of subgalleries 
		
			$galleries[] = $gallery->listGalleries( $GLOBALS['_getVar']['subgallery'] );
			
		}
		
		// render current gallery path
//		if(count($gallery_breadcrumb)) { // -kh
		if(count($gallery_breadcrumb) AND $my_gallery_subid == 0) { // +kh add my_gallery_subid
			array_unshift($galleries, '<div class="gallery_breadcrumb">' . LF . '	' . implode(' / ', $gallery_breadcrumb) . LF . '</div>');
		}

		$gallery = implode(LF, $galleries);


	// list sub galleries in root (parent folder (first level))
	} else {
	
		$gallery_root = $gallery->getGalleryTree();
		
		$g = 0;

		foreach($gallery_root as $row) {
	
			$subgalleries   = $gallery->getGallerySub($row['f_id']);
			
			$subgallery		= '';
			if(is_array($subgalleries) AND count($subgalleries)) {
				
				$subgallery  = '		<ul class="sub">' . LF;
				
				foreach($subgalleries as $sub) {
					
					$subgallery .= '			<li class="sub">' . LF;
					$subgallery .= '				<h3><a href="'.$gallery->url.'&amp;subgallery='.$sub['f_id'].'">';
					$subgallery .=					html_specialchars($sub['f_name']).'</a></h3>' . LF;
					if($row['f_longinfo'] != '') {
						$subgallery .= '		' . plaintext_htmlencode($sub['f_longinfo']) . LF;
					}
					$subgallery .= '			</li>' . LF;
				}
				
				$subgallery .= '		</ul>' . LF;
			}
			
			$galleries[$g]  = '	<li class="root">' . LF;
			$galleries[$g] .= '		<h2>';
			
			if($subgallery != '') {
				$galleries[$g] .= html_specialchars($row['f_name']);
			} else {
				$galleries[$g] .= '<a href="'.$gallery->url.'&amp;subgallery='.$row['f_id'].'">' . html_specialchars($row['f_name']) . '</a>';
			}
			
			$galleries[$g] .= '</h2>' . LF;
			if($row['f_longinfo'] != '') {
				$galleries[$g] .= '		' . plaintext_htmlencode($row['f_longinfo']) . LF;
			}
			$galleries[$g] .= $subgallery;	
			$galleries[$g] .= '	</li>';
			$g++;

		}
		
				
		$gallery = count($galleries) ? '<ul class="gallery">' . LF . implode(LF, $galleries) . LF . '</ul>' : '';
	
	}
// return '<hr /><h1>Gallery</h1>'.LF.$gallery.LF.'<hr />';
return $gallery;
}

/** ====================================================================
 * Same as /img/cmsimage, but only the inner function call  20.02.09 KH
 * $inner_data='/%WIDTH%x%HEIGHT%x%CROP%x%QUALITY%/%HASH%.%EXT%'
 * ====================================================================
 */
	function inner_cmsimage ($inner_data='') {
	
	$phpwcms	= array();
	
	// get segments: cmsimage.php/%WIDTH%x%HEIGHT%x%CROP%x%QUALITY%/%HASH%.%EXT%
	// by default this should be enough: cmsimage.php/%WIDTH%x%HEIGHT/%HASH%.%EXT%
	
	
	$data				= explode('/', $inner_data, 2); 
	
	if(isset($data[1]) && !preg_match('/[^a-fgijpnxA-FGIJPN0-9\/\.]/', $data[1])) {
	
		$data = explode('/', $data[1]);
		
		// first check hashed data
		if(isset($data[1])) {
	
			$data[0]	= preg_replace('/[^0-9x]/', '', $data[0]);
			$data[1]	= preg_replace('/[^a-fgijpn0-9\.]/i', '', $data[1]);

			$value		= array();

			$hash		= cut_ext($data[1]);
			$ext		= which_ext($data[1]);
		
			if(is_numeric($hash)) {
		
//			require_once(PHPWCMS_ROOT.'/include/inc_lib/dbcon.inc.php');
			
				$sql   = 'SELECT f_hash, f_ext FROM '.DB_PREPEND.'phpwcms_file WHERE ';
				$sql  .= 'f_id='.intval($hash)." AND ";
				if(!$phpwcms['imagick']) {
					$sql .= "f_ext IN ('jpg','jpeg','png','gif','bmp') AND ";
				}
				$sql  .= 'f_trash=0 AND f_aktiv=1 AND f_public=1';
				$hash  = _dbQuery($sql);
				if(isset($hash[0]['f_hash'])) {
					$ext  = $hash[0]['f_ext'];
					$hash = $hash[0]['f_hash'];
				} else {
					$hash = '';
					$ext  = '';
				}
			}
		
		
			if($hash && strlen($hash) == 32 && $ext) {
				
				$attribute	= explode('x', $data[0]);
				$width		= intval($attribute[0]);
				$height		= isset($attribute[1]) ? intval($attribute[1]) : 0;
				$crop		= isset($attribute[2]) ? (intval($attribute[2]) ? 1 : 0) : 0;
				
				// quality
				if(isset($attribute[3]) && ($quality = intval($attribute[3])) ) {
					if($quality < 10 || $quality > 100) {
						$quality = '';
					} else {
						$value['jpg_quality'] = $quality;
					}
				} else {
					$quality = '';
				}
			
				if($width) {
					$value["max_width"]		= $width;
				} else {
					$width					= '';
				}
				if($height) {
					$value["max_height"]	= $height;
				} else {
					$height					= '';
				}
				$value['target_ext']		= $ext;
				$value['image_name']		= $hash . '.' . $ext;
				$value['thumb_name']		= md5($hash.$width.$height.$phpwcms['sharpen_level'].$crop.$quality);
				$value['crop_image']		= $crop;
				
				$image = get_cached_image( $value, false, false );
			
				if(!empty($image[0])) {
//				headerRedirect(PHPWCMS_URL.PHPWCMS_IMAGES.$image[0], 301);
					return $image[0];
				
				}

			}

		}

	}
	
// something did not work - redirect to transparent pixel image
// headerRedirect(PHPWCMS_URL.'img/leer.gif', 301);
	
	return 'img/leer.gif';
	
	}
// ====================================================================
// ====================================================================


	$content["all"] = preg_replace('/\{GALLERYX:(.*?)\}/e', 'my_parameter("$1");', $content["all"]);

?>